<?

/**
 * server.php
 * 
 * This file contains additional web services called by the studip om plugin   
 * 
 * Version: 1.0.0
 * Date: 29.06.2010
 * Copyright: Heiko Dostert (dostert@uni-trier.de), Jrg Rpke (roepke@uni-trier.de)
 * License: Eclipse Public License 1.0 (http://www.eclipse.org/legal/epl-v10.html)
 */


include("server_config.php");


$server = new SoapServer(NULL, $options);


$server->addFunction("getCapacity");
$server->addFunction("setRoom");
$server->addFunction("deleteRoom");
$server->addFunction("getRefRecords");
$server->addFunction("getRoomSize");
$server->handle();



// Datenbank
// lesen: $read-> TRUE
function myDB($sql_query, $read = FALSE, $array = FALSE)
{
	global $MAIL_ADMIN, $SUBJECT, $DB_HOST, $DB_USER, $DB_PASSWORD, $DB_DATABASE;
	
	$my_rows = NULL;
	$connection = mysql_connect($DB_HOST, $DB_USER, $DB_PASSWORD);
	
	if (!$connection) {
		die(mail($MAIL_ADMIN, $SUBJECT, 'Keine DB-Verbindung mglich: ' . mysql_error()));
	}
	
	mysql_select_db($DB_DATABASE);
	
	mysql_query('SET NAMES = utf8');

	$result = mysql_query($sql_query);
	
	
	if($read == TRUE && $array == TRUE){
		$my_rows = array();
		while ($row = mysql_fetch_assoc($result)) {
   			$my_rows[] = $row;  
		}
		$result = $my_rows;
	}
	elseif($read == TRUE){
		$result = mysql_result($result, 0);
	}
	
	mysql_close($connection);
	
	return $result;
}



// Freie Kapazitaet des Servers ermitteln
// Berechnung: Tabelle:rooms:numberOfPartizipants - $MAXcAPACITY
function getCapacity($myStartTime, $myEndTime, $my_pwd)
{
	global $MAXcAPACITY, $PWD;
	
	if($my_pwd != $PWD)
		return FALSE;
	
	$capacity = 0;
	//$myStartTime = $this->convertTimestamp($myStartTime);
	//$myEndTime = $this->convertTimestamp($myEndTime);
	
	$sql_query  = "SELECT SUM(opm.numberOfPartizipants) AS summe ";
	$sql_query .= "FROM  rooms AS opm, rooms_studip AS studip ";
	$sql_query .= "WHERE ((studip.startTime <= '$myEndTime' AND studip.endTime >= '$myStartTime')) ";
	$sql_query .= "AND studip.rooms_id = opm.rooms_id";
	
	$capacity = $MAXcAPACITY - myDB($sql_query, TRUE);
	
	if($capacity < 0) {
		$capacity = 0;
	}
	
	return $capacity;
}

// Wird ein Raum angelegt, so muss auch die Tabelle rooms_studip 
// befuellt werden. Diese Tabelle "erweitert" die Tabelle rooms um den 
function setRoom($rooms_id, $startTime, $endTime, $archiveTime, $installationName, $my_pwd)
{
	global $PWD;
	
	if($my_pwd != $PWD)
		return FALSE;
	$installationName = utf8_decode($installationName);	
	$sql_query  = "REPLACE INTO rooms_studip SET ";
	$sql_query .= "rooms_id = '$rooms_id', ";
	$sql_query .= "startTime = '$startTime', ";
	$sql_query .= "endTime = '$endTime', ";
	$sql_query .= "archiveTime = '$archiveTime', ";
	$sql_query .= "installationName = '$installationName'";

	myDB($sql_query);
	
	return TRUE;
}

// Wird ein Raum geloescht, muss er auch aus der Tabelle rooms_id geloescht werden:
function deleteRoom($rooms_id, $my_pwd){
	global $PWD, $INSTALLATION, $ABSOLUTE_PATH;
	if($my_pwd != $PWD)
		return FALSE;
	$sql_query = "DELETE FROM rooms_studip WHERE rooms_id = $rooms_id";	
	myDB($sql_query);
	$sql_query = "DELETE FROM soaplogin WHERE room_id = $rooms_id";	
	myDB($sql_query);
	$sql_query = "DELETE FROM rooms WHERE rooms_id = $rooms_id";	
	myDB($sql_query);
	
	//Auch sonstige Hinterlassenschaften beseitigen:
	//ACHTUNG: Webservice braucht Schreibrechte fuer relevante Ordner! 
	$sql_query = "SELECT * FROM flvrecording WHERE room_id = $rooms_id";
	$result = myDB($sql_query);
	while($row = mysql_fetch_assoc($result)){
		$alternate_download = $row['alternate_download'];
		$filehash = $row['filehash'];
		$preview_image = $row['preview_image'];
		exec("rm -f '$ABSOLUTE_PATH/streams/hibernate/$alternate_download'");
		$test .= "rm -f '$ABSOLUTE_PATH/streams/hibernate/$alternate_download'\n";
		exec("rm -f '$ABSOLUTE_PATH/streams/hibernate/$filehash'");
		exec("rm -f '$ABSOLUTE_PATH/streams/hibernate/$preview_image'");
		$sql_query = "DELETE FROM flvrecording_log WHERE flvrecording_id = ".$row['flvrecording_id'];
		myDB($sql_query);
		$sql_query = "SELECT * FROM flvrecording_metadata WHERE flvrecording_id = ".$row['flvrecording_id'];
		$result2 = myDB($sql_query);
		while($row2 = mysql_fetch_assoc($result2)){
			$sql_query = "DELETE FROM flvrecording_meta_delta WHERE flvrecording_metadata_id = ".$row2['flvrecording_metadata_id'];
			$test .= $sql_query."\n";			
			myDB($sql_query);
		}
		$sql_query = "DELETE FROM flvrecording_metadata WHERE flvrecording_id = ".$row['flvrecording_id'];
		$test .= $sql_query."\n";
		myDB($sql_query);		
	}
	$sql_query = "DELETE FROM flvrecording WHERE room_id = $rooms_id";
	$result = myDB($sql_query);
	exec("rm -r -f '$ABSOLUTE_PATH/streams/$rooms_id'");
	exec("rm -r -f '$ABSOLUTE_PATH/upload/$rooms_id'");
	exec("rm -r -f '$ABSOLUTE_PATH/uploadtemp/$rooms_id'");	
	return TRUE;	
}

// Aufraeumen der Tabelle "rooms_studip" 
function clean($my_pwd)
{
	global $PWD;
	
	if($my_pwd != $PWD)
		return FALSE;
	
	$sql_query  = "SELECT rooms_id FROM rooms_studip ";
	$sql_query .= "WHERE archiveTime < NOW()";
	$result = myDB($sql_query, TRUE, TRUE);
//	print_r($result);
	$i = 0;
	if(is_array($result)){
		foreach($result AS $tupel){
			$i++;
			deleteRoom($tupel['rooms_id'], $PWD);
		}
	}
	return $i;
/*	while($id=mysql_fetch_row($result))
		deleteRoom($id[0], $PWD);*/
}

// Liefert alle Referenzen zu den Aufzeichnungen eines Raumes
function getRefRecords($room_id, $my_pwd) {
	
	global $PWD;
	
	if($my_pwd != $PWD)
		return FALSE;
	
	$sql_query = "SELECT flvrecording_id, alternate_download, record_start, record_end FROM flvrecording WHERE room_id = '$room_id' ORDER BY record_start";
	$records = myDB($sql_query, TRUE, TRUE);
	$result = array();
	foreach($records AS $record)
		$result[] = array('id' => $record['flvrecording_id'], 'file' => $record['alternate_download'], 'start' => $record['record_start'], 'end' => $record['record_end']);

	return $result;
	
}

function getRoomSize($room_id, $my_pwd){
	
	global $PWD;
	
	if($my_pwd != $PWD)
		return FALSE;
		
	$sql_query ="SELECT count(*) as summe FROM conferencelog INNER JOIN conferencelogtype ON conferencelog.conferencelogtype_id = conferencelogtype.conferencelogtype_id WHERE room_id = $room_id AND conferencelogtype.eventtype = 'roomEnter' AND user_id IS NOT NULL";
	$in = myDB($sql_query, TRUE);
	$sql_query ="SELECT count(*) as summe FROM conferencelog INNER JOIN conferencelogtype ON conferencelog.conferencelogtype_id = conferencelogtype.conferencelogtype_id WHERE room_id = $room_id AND conferencelogtype.eventtype = 'roomLeave' AND user_id IS NOT NULL";
	$out = myDB($sql_query, TRUE);
	return ($in - $out);
//	return $room_id;
}

// Entfernt alle Teilnehmer aus abgelaufenen Raeumen:
function kickAllUsersInFinishedRooms($my_pwd){
		global $PWD, $soap_host, $soap_port, $soap_admin, $soap_admin_pw;

		if($my_pwd != $PWD)
			return FALSE;
		
		//Verbindung zu Om aufbauen: 
		try{
			$client_userService = new SoapClient("http://$soap_host:$soap_port/openmeetings/services/UserService?wsdl");
			$result = $client_userService->getSession();
		}
		catch(SoapFault $fault){
			return FALSE;
		}
		$session_id = $result->return->session_id;
		$params = array(
			'SID' => $session_id,
			'username' => $soap_admin,
			'userpass' => $soap_admin_pw
		);
		try{
			$result = $client_userService->loginUser($params);
		}
		catch(SoapFault $fault){
			return FALSE;
		}
		
		//In Db nach abgelaufenen Raeumen suchen: 
		$sql_query =  'SELECT rooms_id FROM rooms_studip WHERE endTime < Now() AND kicked_users=0';
		$results = myDB($sql_query, TRUE, TRUE);
		
		//Fuer alle gefundenen Raeume ausfuehren:
		$i = 0;
		foreach($results AS $result){
  			$params = array(
				'SID_Admin' => $session_id,
				'room_id' => $result['rooms_id']
  				);
			 /*$params = array(
				'SID' => $session_id,
				'room_id' => $result['rooms_id'],
				'status' => TRUE
  				);*/
  			try{
				
				$client_roomService = new SoapClient("http://$soap_host:$soap_port/openmeetings/services/RoomService?wsdl");
				$client_roomService->kickUser($params);
				//$client_roomService->closeRoom($params);
				
				//sleep(5);
				//$params['status'] = FALSE;
				//$client_roomService->closeRoom($params);
				
				$sql_query = 'UPDATE rooms_studip SET kicked_users=1 WHERE rooms_id='.$result['rooms_id'];
				myDB($sql_query);
  			}
  			catch(SoapFault $fault){
	  			return false;
  			}
  			$i++;
  		}
  		return $i;
}
?>